
interface Dut#(type t);
	method ActionValue#(t) rmw_x(t a);
	method ActionValue#(t) rmw_y(t a);
endinterface

(* synthesize *)
module mkDutFix(Dut#(Bit#(4)));
	Reg#(Bit#(4)) x <- mkRegU;
	Reg#(Bit#(4)) y <- mkRegU;

	rule a (x > 0);
		x <= y;
	endrule

	rule b (y < 3);
		y <= y + 1;
	endrule

	method ActionValue#(Bit#(4)) rmw_x(Bit#(4) a) if(x < 2);
		x <= a;
		return x;
	endmethod

	method ActionValue#(Bit#(4)) rmw_y(Bit#(4) a) if(y > 0);
		y <= a;
		return y;
	endmethod
endmodule

module mkDutPoly(Dut#(t)) provisos(Alias#(t, Bit#(sz)), Add#(a__, 2, sz));
	Reg#(t) x <- mkRegU;
	Reg#(t) y <- mkRegU;

	rule a (x > 0);
		x <= y;
	endrule

	rule b (y < 3);
		y <= x;
	endrule

	method ActionValue#(t) rmw_x(t a) if(x < 2);
		x <= a;
		return x;
	endmethod

	method ActionValue#(t) rmw_y(t a) if(y > 0);
		y <= a;
		return y;
	endmethod
endmodule

(* synthesize *)
module mkTb();
	Dut#(Bit#(4)) dut <- mkDutFix;
//	Dut#(Bit#(4)) dut <- mkDutPoly;

	Reg#(Bit#(4)) cyc <- mkReg(0);

	rule clk;
		cyc <= cyc + 1;
		if(cyc == maxBound) begin
			$finish;
		end
	endrule

	rule x;
		let new_v = cyc;
		let old_v = dut.rmw_x(new_v);
		$display("x: %d -> %d", old_v, new_v);
	endrule

	rule y;
		let new_v = cyc + 1;
		let old_v = dut.rmw_y(new_v);
		$display("y: %d -> %d", old_v, new_v);
	endrule
endmodule
